
	//Model of jsobject. All should have at least those methods implemented
	JsDateEdit = function(name)
	{
		//JsObject properties
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsDateEdit";
		this.menu				= null;
		this.parent				= null;
		this.childList			= new Array();

		//JsObject events
		this.events				= new Array();
		
		//JsObject main container
		this.output				= document.createElement("div");

		eval(this.id + "cal		= new JsCalendar('" + this.id + "cal')");
		eval(this.id + "wgrid	= new JsWidgetGrid('" + this.id + "wgrid')");
		eval(this.id + "day		= new JsLineEdit('" + this.id + "day')");
		eval(this.id + "month	= new JsComboBox('" + this.id + "month')");
		eval(this.id + "year	= new JsLineEdit('" + this.id + "year')");
		eval(this.id + "button	= new JsImageButton('" + this.id + "button')");

		this.cal				= eval(this.id + "cal");
		this.wgrid				= eval(this.id + "wgrid");
		this.day				= eval(this.id + "day");
		this.month				= eval(this.id + "month");
		this.year				= eval(this.id + "year");
		this.button				= eval(this.id + "button");

		this.cal.setClass("dateeditcalendar");

		this.date				= new Date;

		this.month.sortable = false;

		for (var js_i in translation[lang]["month"])
		{
			if (this.date.getMonth() == js_i )
				selected = true;
			else
				selected = false;
			if (js_i < 10)
				var monthValue = "0" + js_i;
			else
				var monthValue = js_i;
			this.month.addItem(js_i,translation[lang]["month"][js_i],null,selected);
		}

		this.month.setAttribute("dateedit", this.name);
		this.month.setAttribute("calendar", this.id + "cal");
		this.month.setEvent("change",setJsCalendar);
		
		this.year.setAttribute("dateedit", this.name);
		this.year.setAttribute("calendar", this.id + "cal");
		this.year.setEvent("keyup",setJsCalendar);
		this.year.setEvent("blur",checkJsCalYear);

		this.wgrid.setWidth("203");
		this.day.setWidth(23);
		this.month.setWidth(110);
		this.year.setWidth(40);

		this.button.setSource("images/calendar.gif");
		this.button.setEvent("click",showCalendar);
		this.button.setMenu(this.cal);

		this.cal.previousbutton.setAttribute("donthidemenu","true");
		this.cal.nextbutton.setAttribute("donthidemenu","true");

		for (var js_i in this.cal.childList)
		{
			this.cal.childList[js_i].setAttribute("target", this.name);
			this.cal.childList[js_i].setEvent("click", setDateEditValue);
			this.cal.childList[js_i].setEvent("click", hideActiveHidden);
		}

		this.day.setNumeric();
		this.year.setNumeric();

		this.day.setMaxLength(2);
		this.year.setMaxLength(4);

		this.day.setValue(this.date.getDate());
		if (browserType == "ie")
			this.year.setValue(this.date.getYear());
		else
			this.year.setValue(this.date.getYear() + 1900);

		this.wgrid.addRow();
		this.wgrid.addCell(26);
		this.wgrid.addItem(this.day);
		this.wgrid.addCell(113);
		this.wgrid.addItem(this.month);
		this.wgrid.addCell();
		this.wgrid.addItem(this.year);
		this.wgrid.addCell();
		this.wgrid.addItem(this.button);

		this.output.style.width	= "203";
		this.output.style.height	= "26";

		this.output.appendChild(this.wgrid.output);
		//calendar is appended to document.body for absolute positioning
		document.body.appendChild(this.cal.output);
	}

	/********************************************
				  Exclusive Methods
	********************************************/
	/********************************************
			   End of Exclusive Methods
	********************************************/
	
	/********************************************
				   Values Methods
	********************************************/
	
	JsDateEdit.prototype.getValue = function()
	{
		var js_day = this.day.getValue();
		var js_month = parseInt(this.month.getValue()) + 1;
		var js_year = this.year.getValue();
		if (js_day < 10 && js_day.indexOf("0") != 0)
			js_day = "0" + parseInt(js_day);
		if (js_month < 10)
			js_month = "0" + js_month;

		return js_year + "" +  js_month + "" + js_day;
	}

	JsDateEdit.prototype.setValue = function(value)
	{
		js_day = value.substring(6,8);
		js_month = value.substring(4,6) - 1;
		js_year = value.substring(0,4);
		this.day.setValue(js_day);
		this.month.setValue(js_month);
		this.year.setValue(js_year);
	}

	JsDateEdit.prototype.setAttribute = function(name,value)
	{
		eval("this." + name + " = \"" + value + "\"");
		eval("this.output." + name + " = \"" + value + "\"");
	}
	
	/********************************************
				End of Values Methods
	********************************************/
	
	/********************************************
				   Events Methods
	********************************************/
	
	JsDateEdit.prototype.setMenu = function()
	{
		this.output.menu = obj;
	}
	
	JsDateEdit.prototype.setEvent = function(eventStr,fnc)
	{
		eval("if (this.events['"+eventStr+"']){eventindex = this.events['"+eventStr+"'].length} else {this.events['"+eventStr+"'] = new Array(); eventindex = 0;}")
		eval("eventregistered = false;");
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){eventregistered=true;}}");
		eval("if(!eventregistered){ this.events['"+eventStr+"'][eventindex] = fnc;}");

		if (browserType == "ie")
		{
			this.output.attachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.addEventListener(eventStr, fnc, false);
		}
	}

	JsDateEdit.prototype.unsetEvent = function(eventStr,fnc)
	{
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){this.events['"+eventStr+"'].splice(js_i);}}");

		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}

	JsDateEdit.prototype.disableEvent = function(eventStr,fnc)
	{
		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}
	
	/********************************************
				End of Events Methods
	********************************************/
	
	/********************************************
				   Visual Methods
	********************************************/
	
	JsDateEdit.prototype.setHeight = function(value)
	{
		this.output.style.height = value
	}
	
	JsDateEdit.prototype.setWidth = function(value)
	{
		this.output.style.width = value
	}
	
	JsDateEdit.prototype.setClass = function(value)
	{
		this.output.className = value
	}
	
	JsDateEdit.prototype.setCursor = function(value)
	{
		this.output.style.cursor = value
	}
	
	JsDateEdit.prototype.setFont = function(value)
	{
		this.output.style.fontFamily = value
	}
	
	JsDateEdit.prototype.setFontColor = function(value)
	{
		this.output.style.color = value
	}
	
	JsDateEdit.prototype.setFontSize = function(value)
	{
		this.output.style.fontSize = value
	}
	
	JsDateEdit.prototype.setFontWeight = function(value)
	{
		this.output.style.fontWeight = value
	}
	
	JsDateEdit.prototype.setFontItalic = function(value)
	{
		this.output.style.fontStyle = value
	}
	
	/********************************************
				End of Visual Methods
	********************************************/
	
	/********************************************
				  General Methods
	********************************************/
	
	JsDateEdit.prototype.disable = function(value)
	{
		this.combo.disabled = value;
		if (value)
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.disableEvent(js_i,this.events[js_i][js_j])
			}
		}
		else
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.setEvent(js_i,this.events[js_i][js_j])
			}
		}
	}
	
	/********************************************
			  End of General Methods
	********************************************/

	function showCalendar(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}

		e.cancelBubble = true;

		caltop = e.clientY + document.body.scrollTop;
		calleft = e.clientX + document.body.scrollLeft;

		if ((caltop + parseInt(obj.menu.output.style.height)) > parseInt(document.body.clientHeight))
			caltop =  e.clientY - parseInt(obj.menu.output.style.height) + parseInt(document.body.scrollTop);

		if ((calleft + parseInt(obj.menu.output.style.width)) > parseInt(document.body.clientWidth))
			calleft = e.clientX - parseInt(obj.menu.output.style.width) + parseInt(document.body.scrollLeft);

		if (obj.menu)
			showMenu(obj,caltop,calleft);

		document.onclick = hideActiveHidden;
		top.activehidden = obj.menu;
		top.showmenus = false;
	}

	function setDateEditValue(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}

		e.cancelBubble = true;

		source_obj = eval(obj.parentObj);
		target_obj = eval(obj.target);

		target_obj.setValue(source_obj.getValue());
	}

	function setJsCalendar(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}

		e.cancelBubble = true;

		source_obj = eval(obj.dateedit);
		target_obj = eval(obj.calendar);

		target_obj.setValue(source_obj.getValue());

	}
	
	function checkJsCalYear(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}
		if (obj.value.length !=4)
		{
			alert(translation[lang]["error"][0]);
			if (browserType == "ie")
				obj.focus();
		}
	}
