
	JsListViewItem = function(name)
	{
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsListViewItem";
		this.parent				= null;
		this.listview			= null;
		this.menu				= null;
		this.setopen			= true;
		this.cells				= new Array();
		this.childList			= new Array();
		this.level				= 0;

		//JsObject events
		this.events				= new Array();

		//listviewitem main container
		this.output 			= document.createElement("div");
		
		//arrow to show node state
		this.arrow_img = eval (this.name +"_img = new JsImageButton(\""+this.name+"_img\");");
		this.arrow_img.setEvent("click",expandTreeNode);
		this.arrow_img.setAttribute("parentnode",this.name);
		this.arrow_img.setAttribute("imgname",this.name +"_img");
		this.arrow_img.setAttribute("lstitemparent", this.name);
		this.arrow_img.setCursor("pointer");

		//listviewitem header container
		this.lvitemtab		 		= document.createElement("table");
		this.lvitemtab.lstitemparent= this.name;
		this.lvitemrow 				= this.lvitemtab.insertRow(this.lvitemtab.rows.length);
		this.lvitemrow.lstitemparent= this.name;
		this.lvitemtab.className	= "lvitemtab";
		
		//listviewitem child container
		this.lvitemchilddiv = document.createElement("div");

		//Now we append them all together
		this.output.appendChild(this.lvitemtab);
		this.output.appendChild(this.lvitemchilddiv);

		this.setEvent("click", listviewitemSelect);
		this.setEvent("click", hideActiveHidden);
		this.setEvent("contextmenu", listviewitemSelect);
		this.setAttribute("parent", this.name);
	}

	/********************************************
				  Exclusive Methods
	********************************************/
	/********************************************
			   End of Exclusive Methods
	********************************************/
	
	//Add an item to a listviewitem. If item is of type listviewitem, its added as a child;
	//otherwise it's a cell of the listviewitem row
	//If you wish to add a listviewitem for the construction of a treeview, use the method as bellow
	JsListViewItem.prototype.addItem = function(js_listviewitem_obj){}
	//If you wish to add another object into a listviewitem cell, use the method as bellow
	JsListViewItem.prototype.addItem = function(any_js_Obj){}
	//If you wish to add plain text, use the method as bellow
	JsListViewItem.prototype.addItem = function(your_string,your_icon,is_editable){}
	
	JsListViewItem.prototype.addItem = function()
	{
		if (browserType=="ie")
			var fixsize = 10;
		else
			var fixsize = 12;
		//first condition not tested and/or implemented
		if (arguments[0].type == "JsListViewItem")
		{
			var index = this.childList.length;
			this.childList[index] = arguments[0];
			this.childList[index].parent = this;
			this.childList[index].listview = this.listview;
			this.childList[index].level = this.level + 1;
			this.lvitemchilddiv.appendChild(this.childList[index].output);
			this.listview.istreeview = true;
			this.lvitemchilddiv.style.visibility="visible";
			this.lvitemchilddiv.style.display="block";
			this.setopen = true;
			//sets if childs are visible or not when listview is a treeview
			this.arrow_img.setSource("images/down_arrow.gif");
			return true;
		}
		else
		{
			if (arguments[0].type)
			{
				if (this.listview.istreeview && index == 0 && arguments[0].type!="JsLabel")
				{
					alert("Invalid object type for treeview column");
					return false;
				}
				var index = this.cells.length;
				var cell = this.lvitemrow.insertCell(this.lvitemrow.cells.length);
				cell.lstitemparent		= this.name;
				this.cells[index] = arguments[0];
				this.cells[index].setEvent("click", listviewitemSelect);
				this.cells[index].setEvent("click", hideActiveHidden);
				this.cells[index].setAttribute("lstitemparent", this.name);
				this.cells[index].parent = this;
				arguments[0].parent = this;
				cell.appendChild(arguments[0].output);
				cell.parent = this;
				cell.style.width = parseInt(this.listview.headers[index].style.width) + fixsize;
				cell.className	= "lvitemcell"
				this.lvitemtab.style.width = this.listview.lvheadertab.style.width;
			}
			else
			{
				var index = this.cells.length;
				var cell = this.lvitemrow.insertCell(this.lvitemrow.cells.length);
				cell.lstitemparent		= this.name;
				eval (this.id + "_" + index + " = new JsLabel('" + this.id + "_" + index + "')");
				this.cells[index] = eval(this.id + "_" + index);
				if (arguments[2])
					this.cells[index].setEditable();
				this.cells[index].setValue(arguments[0]);
				this.cells[index].setEvent("click", listviewitemSelect);
				this.cells[index].setEvent("click", hideActiveHidden);
				this.cells[index].setAttribute("lstitemparent", this.name);
				this.cells[index].parent = this;
				if (arguments[1])
					this.cells[index].setIcon(arguments[1]);
				
				
				cell.appendChild(this.cells[index].output);
				cell.parent = this;
				cell.style.width = parseInt(this.listview.headers[index].style.width) + fixsize;
				cell.className	= "lvitemcell";
				this.lvitemtab.style.width = this.listview.lvheadertab.style.width;
				
				if (this.listview.istreeview && index == 0)
				{
					if (this.cells[index].iconcell)
						var arrow_index = this.cells[index].labelrow.cells.length - 2;
					else
						var arrow_index = this.cells[index].labelrow.cells.length - 1;
					cell = this.cells[index].labelrow.insertCell(arrow_index);
					cell.style.width = "7";
					cell.lstitemparent = this.name;
				
					if (this.parent.childList.length==1 && this.parent.type=="JsListViewItem")
					{
						if (this.parent.cells[index].iconcell)
							var arrow_index = this.parent.cells[index].labelrow.cells.length - 3;
						else
							var arrow_index = this.parent.cells[index].labelrow.cells.length - 2;
						//if (this.parent==this.listview.childList[0])
							//cell = this.parent.cells[index].labelrow.insertCell(0);
						//else
							cell = this.parent.cells[index].labelrow.cells[arrow_index];
						cell.lstitemparent = this.parent.name;
						cell.parentObj = this.parent.cells[index].name;
						cell.style.width = "7";
						if (arguments[2])
							this.parent.arrow_img.setAttribute('parentObj',this.parent.cells[index].name);
						cell.appendChild(this.parent.arrow_img.output);
					}
					
					for (js_i=0;js_i<this.level;js_i++)
					{
						var blank_img = document.createElement("img");
						blank_img.src = "images/blank.gif";
						blank_img.lstitemparent = this.name;
						if (arguments[2])
							blank_img.parentObj = this.cells[index].name;
						cell = this.cells[index].labelrow.insertCell(0);
						cell.lstitemparent = this.name
						blank_img.width = "16";
						cell.style.width = "16";
						cell.appendChild(blank_img);
					}
				}
			}
		}
	}
	
	JsListViewItem.prototype.delItem = function(obj)
	{
		var obj;
		var tempList = new Array();
		for (var js_i in this.childList)
		{
			if (this.childList[js_i].name != obj.name)
				tempList[tempList.length] = this.childList[js_i];
			else
			{
				if (obj.childList.length > 0)
				{
					for (var js_j in obj.childList)
						obj.delItem(obj.childList[js_j]);
				}
				obj.output.parentNode.removeChild(obj.output);
				delete obj;
			}
		}
		this.childList = new Array();
		this.childList = tempList;
		tempList = null;
	}
	
	JsListViewItem.prototype.setItem = function (obj, index)
	{
	}

	JsListViewItem.prototype.setAttribute = function(name,value)
	{
		eval("this." + name + " = \"" + value + "\"");
		eval("this.output." + name + " = \"" + value + "\"");
		eval("this.lvitemtab." + name + " = \"" + value + "\"");
		eval("this.lvitemrow." + name + " = \"" + value + "\"");
	}

	JsListViewItem.prototype.getAttribute = function(name,value)
	{
		return eval("this." + name);
	}

	/********************************************
				   Values Methods
	********************************************/

	//Returns an array with the values of the children
	JsListViewItem.prototype.getValue = function()
	{
		var values = new Array();
		for (var js_i in this.cells)
			values[js_i] = this.cells[js_i].getValue();
		
		if (this.listview.istreeview)
		{
			js_i = values.length;
			values[js_i] = new Array();
			for (var js_j in this.childList)
				values[js_i][js_j] = this.childList[js_j].getValue();
		}

		return values;
	}

	/********************************************
				End of Values Methods
	********************************************/

	/********************************************
				   Events Methods
	********************************************/
	
	JsListViewItem.prototype.setMenu = function(obj)
	{
		this.unsetEvent("contextmenu", listviewitemSelect);
		obj.parent = this;
		for (js_i in this.cells)
		{
			this.cells[js_i].setMenu(obj);
			this.cells[js_i].setEvent("contextmenu", showContextMenu);
		}
		this.output.menu = obj;
		this.lvitemtab.menu = obj;
		this.lvitemrow.menu = obj;
		for (js_i=0;js_i<this.lvitemrow.cells.length;js_i++)
			this.lvitemrow.cells[js_i].menu = obj;

		if (browserType=="ie")
		{
			this.output.attachEvent("oncontextmenu", showContextMenu);
			this.lvitemtab.attachEvent("oncontextmenu", showContextMenu);
			this.lvitemrow.attachEvent("oncontextmenu", showContextMenu);
			for (js_i=0;js_i<this.lvitemrow.cells.length;js_i++)
				this.lvitemrow.cells[js_i].attachEvent("oncontextmenu", showContextMenu);
		}
		else
		{
			this.output.addEventListener("contextmenu", showContextMenu,false);
			this.lvitemtab.addEventListener("contextmenu", showContextMenu,false);
			this.lvitemrow.addEventListener("contextmenu", showContextMenu,false);
			for (js_i=0;js_i<this.lvitemrow.cells.length;js_i++)
				this.lvitemrow.cells[js_i].addEventListener("contextmenu", showContextMenu,false);
		}
		this.setEvent("contextmenu", listviewitemSelect);
	}
	
	JsListViewItem.prototype.setEvent = function(eventStr,fnc)
	{
		eval("if (this.events['"+eventStr+"']){eventindex = this.events['"+eventStr+"'].length} else {this.events['"+eventStr+"'] = new Array(); eventindex = 0;}")
		eval("eventregistered = false;");
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){eventregistered=true;}}");
		eval("if(!eventregistered){ this.events['"+eventStr+"'][eventindex] = fnc;}");

		if (browserType == "ie")
		{
			this.output.attachEvent("on" + eventStr, fnc);
			this.lvitemtab.attachEvent("on" + eventStr, fnc);
			this.lvitemrow.attachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.addEventListener(eventStr, fnc, false);
			this.lvitemtab.addEventListener(eventStr, fnc, false);
			this.lvitemrow.addEventListener(eventStr, fnc, false);
		}
		
		for (js_i in this.cells)
			this.cells[js_i].setEvent(eventStr, fnc);
	}

	JsListViewItem.prototype.unsetEvent = function(eventStr,fnc)
	{
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){this.events['"+eventStr+"'].splice(js_i);}}");

		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
			this.lvitemtab.detachEvent("on" + eventStr, fnc);
			this.lvitemrow.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
			this.lvitemtab.removeEventListener(eventStr, fnc, false);
			this.lvitemrow.removeEventListener(eventStr, fnc, false);
		}
		for (js_i in this.cells)
			this.cells[js_i].unsetEvent(eventStr, fnc);
	}

	JsListViewItem.prototype.disableEvent = function(eventStr,fnc)
	{
		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
			this.lvitemtab.detachEvent("on" + eventStr, fnc);
			this.lvitemrow.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
			this.lvitemtab.removeEventListener(eventStr, fnc, false);
			this.lvitemrow.removeEventListener(eventStr, fnc, false);
		}
		for (js_i in this.cells)
			this.cells[js_i].disableEvent(eventStr, fnc);
	}
	
	/********************************************
				End of Events Methods
	********************************************/
	
	/********************************************
				   Visual Methods
	********************************************/
	
	JsListViewItem.prototype.setHeight = function(value)
	{
		this.output.style.height = value
	}
	
	JsListViewItem.prototype.setWidth = function(value)
	{
		this.output.style.width = value
	}
	
	JsListViewItem.prototype.setClass = function(value)
	{
		this.output.className = value
	}
	
	JsListViewItem.prototype.setCursor = function(value)
	{
		this.output.style.cursor = value
	}
	
	JsListViewItem.prototype.setFont = function(value)
	{
		this.output.style.fontFamily = value
	}
	
	JsListViewItem.prototype.setFontColor = function(value)
	{
		this.output.style.color = value
	}
	
	JsListViewItem.prototype.setFontSize = function(value)
	{
		this.output.style.fontSize = value
	}
	
	JsListViewItem.prototype.setFontWeight = function(value)
	{
		this.output.style.fontWeight = value
	}
	
	JsListViewItem.prototype.setFontItalic = function(value)
	{
		this.output.style.fontStyle = value
	}
	
	/********************************************
				End of Visual Methods
	********************************************/
	
	/********************************************
				  General Methods
	********************************************/
	
	JsListViewItem.prototype.disable = function(value)
	{
		this.combo.disabled = value;
		if (value)
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.disableEvent(js_i,this.events[js_i][js_j])
			}
		}
		else
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.setEvent(js_i,this.events[js_i][js_j])
			}
		}
	}
	
	/********************************************
			  End of General Methods
	********************************************/

	/********************************************
				External Functions
	********************************************/

	function listviewitemSelect(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}
		if (e.type == "contextmenu" && browserType == "ie")
			e.returnValue = false;
		e.cancelBubble = true;

		target_obj = eval(obj.lstitemparent);
		currentItem = target_obj.listview.selectedItem
		if (currentItem)
		{
			for (var i in currentItem.lvitemrow.childNodes)
				currentItem.lvitemrow.childNodes[i].className = "lvitemcell";
			for (var i in currentItem.cells)
				currentItem.cells[i].setClass("lvitemcellcontent");
		}
		//if (target_obj.listview.selectedItem != target_obj)
		{
			for (var i in target_obj.lvitemrow.childNodes)
				target_obj.lvitemrow.childNodes[i].className = "lvitemcellselected";
			for (var i in target_obj.cells)
				target_obj.cells[i].setClass("lvitemcellcontentselected");
			target_obj.listview.selectedItem = target_obj;
		}
		//else
			//target_obj.listview.selectedItem = null;
	}
	
	function expandTreeNode(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}
		
		target_lst = eval(obj.parentnode);
		target_img = eval(obj.imgname);
		if (target_lst.setopen)
		{
			target_lst.lvitemchilddiv.style.visibility = "hidden";
			target_lst.lvitemchilddiv.style.display = "none";
			target_lst.setopen = false;
			target_img.setSource("images/right_arrow.gif");
		}
		else
		{
			target_lst.lvitemchilddiv.style.visibility = "visible";
			target_lst.lvitemchilddiv.style.display = "block";
			target_lst.setopen = true;
			target_img.setSource("images/down_arrow.gif");
		}
	}
