
	//Model of jsobject. All should have at least those methods implemented
	JsObjectModel = function(name)
	{
		//JsObject properties
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "jsobjectmodel";
		this.menu				= null;
		this.parent				= null;
		this.childList			= new Array();

		//JsObject events
		this.events				= new Array();
		
		//JsObject main container
		this.output				= document.createElement("div");
	}

	/********************************************
				  Exclusive Methods
	********************************************/
	/********************************************
			   End of Exclusive Methods
	********************************************/
	
	/********************************************
				   Content Methods
	********************************************/
	
	JsObjectModel.prototype.addItem = function()
	{
		this.childList[this.childList.length] = obj;
		obj.parent = this;
	}
	
	JsObjectModel.prototype.delItem = function()
	{
	}
	
	JsObjectModel.prototype.setItem = function()
	{
	}
	
	/********************************************
				End of Content Methods
	********************************************/
	
	/********************************************
				   Values Methods
	********************************************/
	
	JsObjectModel.prototype.getValue = function()
	{
	}
	
	JsObjectModel.prototype.setValue = function()
	{
	}

	JsObjectModel.prototype.setAttribute = function(name,value)
	{
		eval("this." + name + " = \"" + value + "\"");
		eval("this.output." + name + " = \"" + value + "\"");
	}
	
	/********************************************
				End of Values Methods
	********************************************/
	
	/********************************************
				   Events Methods
	********************************************/
	
	JsObjectModel.prototype.setMenu = function()
	{
		this.output.menu = obj;
	}
	
	JsObjectModel.prototype.setEvent = function(eventStr,fnc)
	{
		eval("if (this.events['"+eventStr+"']){eventindex = this.events['"+eventStr+"'].length} else {this.events['"+eventStr+"'] = new Array(); eventindex = 0;}")
		eval("eventregistered = false;");
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){eventregistered=true;}}");
		eval("if(!eventregistered){ this.events['"+eventStr+"'][eventindex] = fnc;}");

		if (browserType == "ie")
		{
			this.output.attachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.addEventListener(eventStr, fnc, false);
		}
	}

	JsObjectModel.prototype.unsetEvent = function(eventStr,fnc)
	{
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){this.events['"+eventStr+"'].splice(js_i);}}");

		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}

	JsObjectModel.prototype.disableEvent = function(eventStr,fnc)
	{
		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}
	
	/********************************************
				End of Events Methods
	********************************************/
	
	/********************************************
				   Visual Methods
	********************************************/
	
	JsObjectModel.prototype.setHeight = function(value)
	{
		this.output.style.height = value
	}
	
	JsObjectModel.prototype.setWidth = function(value)
	{
		this.output.style.width = value
	}
	
	JsObjectModel.prototype.setClass = function(value)
	{
		this.output.className = value
	}
	
	JsObjectModel.prototype.setCursor = function(value)
	{
		this.output.style.cursor = value
	}
	
	JsObjectModel.prototype.setFont = function(value)
	{
		this.output.style.fontFamily = value
	}
	
	JsObjectModel.prototype.setFontColor = function(value)
	{
		this.output.style.color = value
	}
	
	JsObjectModel.prototype.setFontSize = function(value)
	{
		this.output.style.fontSize = value
	}
	
	JsObjectModel.prototype.setFontWeight = function(value)
	{
		this.output.style.fontWeight = value
	}
	
	JsObjectModel.prototype.setFontItalic = function(value)
	{
		this.output.style.fontStyle = value
	}
	
	/********************************************
				End of Visual Methods
	********************************************/
	
	/********************************************
				  General Methods
	********************************************/
	
	JsObjectModel.prototype.disable = function(value)
	{
		this.combo.disabled = value;
		if (value)
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.disableEvent(js_i,this.events[js_i][js_j])
			}
		}
		else
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.setEvent(js_i,this.events[js_i][js_j])
			}
		}
	}
	
	/********************************************
			  End of General Methods
	********************************************/
