
	//Model of jsobject. All should have at least those methods implemented
	JsDataConnector = function(name)
	{
		//JsObject properties
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsDataConnector";
		this.menu				= null;
		this.parent				= null;
		this.childList			= new Array();

		//JsObject events
		this.events				= new Array();

		//JsObject main container
		this.output				= document.createElement("div");
		this.form				= document.createElement("form");

		this.form.name			= this.name + "_form";
		this.form.method		= "POST";
		this.form.target		= this.id;

		this.output.appendChild(this.form);

		document.body.appendChild(this.output);
		//this was done just because Internet Explorer
		//does not accept me to create an iframe using pure DOM
		//and use it as target for my form. DAMN GATES!
		document.write('<iframe name="' + this.id + '" id="' + this.id + '" style="visibility:hidden;position:absolute;"></iframe>');
		//document.write('<iframe name="' + this.id + '" id="' + this.id + '"></iframe>');
		this.iframe = document.getElementById(this.id);

		this.output.className	= "dataconnector";
	}

	/********************************************
				  Exclusive Methods
	********************************************/
	JsDataConnector.prototype.setHandler = function(value)
	{
		this.iframe.src			= value;
		this.form.action		= value;
	}

	JsDataConnector.prototype.setFieldValue = function(fieldname, value)
	{
		var field = "<input type=\"hidden\" name=\""+fieldname+"\" value=\""+value+"\">";
		this.form.innerHTML += field;
	}

	JsDataConnector.prototype.postData = function()
	{
		this.form.submit();
		this.cleanData();
	}

	JsDataConnector.prototype.cleanData = function()
	{
		while (this.form.childNodes.length != 0)
		{
			this.form.removeChild(this.form.firstChild);
		}
	}
	/********************************************
			   End of Exclusive Methods
	********************************************/

	/********************************************
				  General Methods
	********************************************/

	JsDataConnector.prototype.disable = function()
	{
	}

	/********************************************
			  End of General Methods
	********************************************/
