
	//Model of jsobject. All should have at least those methods implemented
	JsImage = function(name)
	{
		//JsObject properties
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsImage";
		this.menu				= null;
		this.parent				= null;

		//JsObject events
		this.events				= new Array();
		
		//JsObject main container
		this.output				= document.createElement("div");
		this.img				= document.createElement("img");
		this.img.src			= "images/blank.gif";
		this.output				= this.output.appendChild(this.img);
	}

	/********************************************
				  Exclusive Methods
	********************************************/

	JsImage.prototype.setSource = function(value)
	{
		this.img.src = value;
	}

	/********************************************
			   End of Exclusive Methods
	********************************************/

	/********************************************
				   Visual Methods
	********************************************/
	
	JsImage.prototype.setHeight = function(value)
	{
		this.output.style.height = value;
		this.img.height = value;
	}

	JsImage.prototype.setWidth = function(value)
	{
		this.output.style.width = value;
		this.img.width = value;
	}

	JsImage.prototype.setCursor = function(value)
	{
		this.output.style.cursor = value;
	}

	/********************************************
				End of Visual Methods
	********************************************/
