
	//Model of jsobject. All should have at least those methods implemented
	JsMenuBar = function(name)
	{
		//JsObject properties
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsMenuBar";
		this.menu				= null;
		this.parent				= null;
		this.childList			= new Array();

		//JsObject events
		this.events				= new Array();
		
		//JsObject main container
		this.output				= document.createElement("div");
		this.output.className	= "menubar";
		this.output.style.overflow = "hidden";
		this.menubartab 		= document.createElement("table");
		this.menubartab.className = "menubartable";

		this.menubarrow 		= this.menubartab.insertRow(this.menubartab.rows.length);

		this.output.appendChild(this.menubartab)
	}

	/********************************************
				  Exclusive Methods
	********************************************/
	/********************************************
			   End of Exclusive Methods
	********************************************/
	
	/********************************************
				   Content Methods
	********************************************/
	
	JsMenuBar.prototype.addItem = function(obj)
	{
		if (obj.type != "JsMenu")
		{
			alert("Invalid object type for addition on menubar.");
			return false;
		}

		this.childList[this.childList.length] = obj;
		obj.parent = this;
		obj.contextmenu = false;

		menubaritem = this.menubarrow.insertCell(this.menubarrow.cells.length);
		menubaritem.className = "menubaritem";
		menubaritem.menu = obj;
		menubaritem.innerHTML = "&nbsp;&nbsp;&nbsp;" + obj.value + "&nbsp;&nbsp;&nbsp;";
		if (browserType == "ie")
		{
			menubaritem.attachEvent("onmouseover", setMenuBarItemOver);
			menubaritem.attachEvent("onmouseout", setMenuBarItemOut);
			menubaritem.attachEvent("onclick", showBarMenu);
		}
		else
		{
			menubaritem.addEventListener("mouseover", setMenuBarItemOver, false);
			menubaritem.addEventListener("mouseout", setMenuBarItemOut, false);
			menubaritem.addEventListener("click",showBarMenu,false);
		}
	}
	
	JsMenuBar.prototype.delItem = function(obj)
	{
	}
	
	JsMenuBar.prototype.setItem = function(obj)
	{
	}
	
	/********************************************
				End of Content Methods
	********************************************/
	
	/********************************************
				   Values Methods
	********************************************/
	
	JsMenuBar.prototype.getValue = function()
	{
	}
	
	JsMenuBar.prototype.setValue = function()
	{
	}

	JsMenuBar.prototype.setAttribute = function(name,value)
	{
		eval("this." + name + " = \"" + value + "\"");
		eval("this.output." + name + " = \"" + value + "\"");
	}
	
	/********************************************
				End of Values Methods
	********************************************/

	/********************************************
				   Events Methods
	********************************************/

	JsMenuBar.prototype.setEvent = function(eventStr,fnc)
	{
		eval("if (this.events['"+eventStr+"']){eventindex = this.events['"+eventStr+"'].length} else {this.events['"+eventStr+"'] = new Array(); eventindex = 0;}")
		eval("eventregistered = false;");
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){eventregistered=true;}}");
		eval("if(!eventregistered){ this.events['"+eventStr+"'][eventindex] = fnc;}");

		if (browserType == "ie")
		{
			this.output.attachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.addEventListener(eventStr, fnc, false);
		}
	}

	JsMenuBar.prototype.unsetEvent = function(eventStr,fnc)
	{
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){this.events['"+eventStr+"'].splice(js_i);}}");

		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}

	JsMenuBar.prototype.disableEvent = function(eventStr,fnc)
	{
		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}
	
	/********************************************
				End of Events Methods
	********************************************/
	
	/********************************************
				   Visual Methods
	********************************************/
	
	JsMenuBar.prototype.setHeight = function(value)
	{
		this.output.style.height = value
	}
	
	JsMenuBar.prototype.setWidth = function(value)
	{
		this.output.style.width = value
	}
	
	JsMenuBar.prototype.setClass = function(value)
	{
		this.output.className = value
	}
	
	JsMenuBar.prototype.setCursor = function(value)
	{
		this.output.style.cursor = value
	}
	
	JsMenuBar.prototype.setFont = function(value)
	{
		this.output.style.fontFamily = value
	}
	
	JsMenuBar.prototype.setFontColor = function(value)
	{
		this.output.style.color = value
	}
	
	JsMenuBar.prototype.setFontSize = function(value)
	{
		this.output.style.fontSize = value
	}
	
	JsMenuBar.prototype.setFontWeight = function(value)
	{
		this.output.style.fontWeight = value
	}
	
	JsMenuBar.prototype.setFontItalic = function(value)
	{
		this.output.style.fontStyle = value
	}
	
	/********************************************
				End of Visual Methods
	********************************************/
	
	/********************************************
				  General Methods
	********************************************/
	
	JsMenuBar.prototype.disable = function(value)
	{
		this.combo.disabled = value;
		if (value)
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.disableEvent(js_i,this.events[js_i][js_j])
			}
		}
		else
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.setEvent(js_i,this.events[js_i][js_j])
			}
		}
	}
	
	/********************************************
			  End of General Methods
	********************************************/
