
	//Model of jsobject. All should have at least those methods implemented
	JsToolBar = function(name)
	{
		//JsObject properties
		this.name				= name;
		this.id					= "_" + this.name;
		this.type				= "JsToolBar";
		this.menu				= null;
		this.parent				= null;
		this.childList			= new Array();

		//JsObject events
		this.events				= new Array();

		//JsObject main container
		this.output				= document.createElement("div");
		this.output.className	= "toolbar";
		this.output.style.overflow = "hidden";
		this.toolbartab 		= document.createElement("table");
		this.toolbartab.className = "toolbartable";

		this.toolbarrow 		= this.toolbartab.insertRow(this.toolbartab.rows.length);

		emptycell = this.toolbarrow.insertCell(this.toolbarrow.cells.length);
		emptycell.innerHTML = "&nbsp";
		emptycell.style.width = "0";

		this.output.appendChild(this.toolbartab)
	}

	/********************************************
				  Exclusive Methods
	********************************************/

	JsToolBar.prototype.addDiv = function()
	{
		toolbaritem = this.toolbarrow.insertCell(this.toolbarrow.cells.length);
		hr = document.createElement("hr");
		hr.style.height = "25";
		hr.style.width = "2";
		toolbaritem.appendChild(hr);
	}

	/********************************************
			   End of Exclusive Methods
	********************************************/
	
	/********************************************
				   Content Methods
	********************************************/
	
	JsToolBar.prototype.addItem = function(obj)
	{
		if (obj.type != "JsToolBarButton")
		{
			alert("Invalid object type for addition on toolbar.");
			return false;
		}

		this.childList[this.childList.length] = obj;
		obj.parent = this;

		emptycell = this.toolbarrow.insertCell(this.toolbarrow.cells.length);
		emptycell.innerHTML = "&nbsp";
		emptycell.style.width = "5";
		toolbaritem = this.toolbarrow.insertCell(this.toolbarrow.cells.length);
		toolbaritem.appendChild(obj.output);
		emptycell = this.toolbarrow.insertCell(this.toolbarrow.cells.length);
		emptycell.innerHTML = "&nbsp";
		emptycell.style.width = "5";

		obj.setEvent("mouseover", setToolBarItemOver);
		obj.setEvent("mouseout", setToolBarItemOut);
		obj.setEvent("mousedown", setToolBarItemMouseDown);
		obj.setEvent("mouseup", setToolBarItemOver);
	}
	
	JsToolBar.prototype.delItem = function(obj)
	{
	}
	
	JsToolBar.prototype.setItem = function(obj)
	{
	}
	
	/********************************************
				End of Content Methods
	********************************************/
	
	/********************************************
				   Values Methods
	********************************************/
	
	JsToolBar.prototype.getValue = function()
	{
	}
	
	JsToolBar.prototype.setValue = function()
	{
	}

	JsToolBar.prototype.setAttribute = function(name,value)
	{
		eval("this." + name + " = \"" + value + "\"");
		eval("this.output." + name + " = \"" + value + "\"");
	}
	
	/********************************************
				End of Values Methods
	********************************************/

	/********************************************
				   Events Methods
	********************************************/

	JsToolBar.prototype.setEvent = function(eventStr,fnc)
	{
		eval("if (this.events['"+eventStr+"']){eventindex = this.events['"+eventStr+"'].length} else {this.events['"+eventStr+"'] = new Array(); eventindex = 0;}")
		eval("eventregistered = false;");
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){eventregistered=true;}}");
		eval("if(!eventregistered){ this.events['"+eventStr+"'][eventindex] = fnc;}");

		if (browserType == "ie")
		{
			this.output.attachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.addEventListener(eventStr, fnc, false);
		}
	}

	JsToolBar.prototype.unsetEvent = function(eventStr,fnc)
	{
		eval("for (var js_i in this.events['"+eventStr+"']){if(this.events['"+eventStr+"'][js_i] == fnc){this.events['"+eventStr+"'].splice(js_i);}}");

		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}

	JsToolBar.prototype.disableEvent = function(eventStr,fnc)
	{
		if (browserType == "ie")
		{
			this.output.detachEvent("on" + eventStr, fnc);
		}
		else
		{
			this.output.removeEventListener(eventStr, fnc, false);
		}
	}
	
	/********************************************
				End of Events Methods
	********************************************/
	
	/********************************************
				   Visual Methods
	********************************************/
	
	JsToolBar.prototype.setHeight = function(value)
	{
		this.output.style.height = value
	}
	
	JsToolBar.prototype.setWidth = function(value)
	{
		this.output.style.width = value
	}
	
	JsToolBar.prototype.setClass = function(value)
	{
		this.output.className = value
	}
	
	JsToolBar.prototype.setCursor = function(value)
	{
		this.output.style.cursor = value
	}
	
	JsToolBar.prototype.setFont = function(value)
	{
		this.output.style.fontFamily = value
	}
	
	JsToolBar.prototype.setFontColor = function(value)
	{
		this.output.style.color = value
	}
	
	JsToolBar.prototype.setFontSize = function(value)
	{
		this.output.style.fontSize = value
	}
	
	JsToolBar.prototype.setFontWeight = function(value)
	{
		this.output.style.fontWeight = value
	}
	
	JsToolBar.prototype.setFontItalic = function(value)
	{
		this.output.style.fontStyle = value
	}
	
	/********************************************
				End of Visual Methods
	********************************************/
	
	/********************************************
				  General Methods
	********************************************/
	
	JsToolBar.prototype.disable = function(value)
	{
		this.combo.disabled = value;
		if (value)
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.disableEvent(js_i,this.events[js_i][js_j])
			}
		}
		else
		{
			for (var js_i in this.events)
			{
				for (var js_j in this.events[js_i])
					this.setEvent(js_i,this.events[js_i][js_j])
			}
		}
	}
	
	/********************************************
			  End of General Methods
	********************************************/

	/********************************************
				External Functions
	********************************************/

	/********************************************
	       General functions for bar menus
	********************************************/
	function setToolBarItemOver(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}
		e.cancelBubble = true;
		obj.className = "toolbaritemover";

		/*if (top.showmenus)
		{
			showBarMenu(e);
		}*/
	}

	function setToolBarItemMouseDown(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}
		e.cancelBubble = true;
		obj.className = "toolbaritemmousedown";

		/*if (top.showmenus)
		{
			showBarMenu(e);
		}*/
	}

	function setToolBarItemOut(e)
	{
		if (browserType == "ie")
		{
			e = window.event;
			obj = e.srcElement;
		}
		else
		{
			obj = e.target;
		}
		e.cancelBubble = true;
		obj.className = "toolbaritem";
	}

	/********************************************
			  End of External Functions
	********************************************/
